package levelElements;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.graphics.OrthographicCamera;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.g2d.Sprite;
import com.badlogic.gdx.graphics.g2d.TextureRegion;
import com.badlogic.gdx.math.MathUtils;
import com.badlogic.gdx.math.Rectangle;
import com.ld58.game.rcr;

public class Dirt extends Sprite {// this is a very simple, non animated sprite. Is this the lightest thing I have?
	private TextureRegion main;
	private Texture t1;
	public Color color;
	public Rectangle rect;
	private int _sw;// sprite width
	private int _sh;// sprite height
	public boolean isDead;
	private float timer = .02f;
	private float angle = 1f;
	private float angleSpeed = .01f;
	private float widthX;
	private float heightY;
	private float speed;
	private float originX;
	private float originY;
	private float originSpeed;
	private float ovalIncreaserX;
	private float originOvalIncreaserX;
	private float ovalIncreaserY;
	private float originOvalIncreaserY;

	public Dirt(float _x, float _y) {
		rect = new Rectangle();
		rect.x = (int) _x;
		rect.y = (int) _y;
		rect.width = 10;
		rect.height = 10;
		_sw = 10;
		_sh = 10;
		// still frames
		t1 = new Texture(Gdx.files.internal("onePixel.png"));
		main = new TextureRegion(t1, (0 * _sw), (0 * _sh), _sw, _sh);
		color = new Color(MathUtils.random(.1f, .2f), MathUtils.random(.05f, .1f), MathUtils.random(.001f, .002f), 1);
		setBounds(0, 0, _sw, _sh);
		setOriginCenter();
		setRegion(main);
		originX = widthX = MathUtils.random(300f, 350f);
		originY = heightY = MathUtils.random(300f, 340f);
		originSpeed = speed = MathUtils.random(.1f, 4f);
		angle = MathUtils.random(1f, 360f);
		originOvalIncreaserX = ovalIncreaserX = MathUtils.random(1.2f, 1.5f);
		originOvalIncreaserY = ovalIncreaserY = MathUtils.random(1.2f, 1.5f);
	}

	private void Update() {
		rect.x = timer + widthX + 250 * MathUtils.cos(angle) * ovalIncreaserX;
		rect.y = timer + heightY + 200 * MathUtils.sin(angle) * ovalIncreaserY;
		angle += angleSpeed;
		if (angle >= 360)
			angle = 1;
		timer += speed;
		if (angleSpeed < .01f)
			angleSpeed += .02f;
		if (ovalIncreaserX < 5.0f)
			ovalIncreaserX += .02f;
		if (ovalIncreaserY < 5.0f)
			ovalIncreaserY += .05f;

		if (rect.x < -206 | rect.x > rcr.MW | rect.y < -206 | rect.y > rcr.MH) {
			widthX = originX;
			heightY = originY;
			speed = originSpeed;
			ovalIncreaserX = originOvalIncreaserX;
			ovalIncreaserY = originOvalIncreaserY;
			timer = 0;
			angleSpeed = .01f;
		}
	}

	public TextureRegion getTextureRegion() {
		return main;
	}

	public void render(rcr game, OrthographicCamera camera, float dt) {// hmmm i think it just needs placed before? it gets here.
		Update();
		game.batch.setColor(color);
		game.batch.draw(getTextureRegion(), rect.x, rect.y);
	}

	public void dispose() {
	}
}
